/*
 * File : dlCmdResTimer.h
 * 
 * Description : This file contains the dlCmdResTimer class
 * declaration.
 */

#ifndef _dlCmdResTimer_h_
#define _dlCmdResTimer_h_

#include "timerHandler.h"

/*
 * Class : dlCmdResTimer
 * 
 * Description : This is a timer which inherits from timerHandler,
 * and provides support for the nwlayer to invoke data-link
 * primitives ( response and confirm) asynchronously.
 * The EventCallback() method is redefined to invoke a primitive
 * on the data-link layer when the timer expires.
 *
 * Attributes:
 *	int	_cmd : The primitive to be invoked when this timer expires.
 *	layer *_dl: Pointer to the data-link layer.
 */

class dlCmdResTimer : public timerHandler {

 public:

	dlCmdResTimer(int cmd, layer *dl) : 
		_dl(dl), _cmd(cmd), timerHandler(0) {};
	virtual ~dlCmdResTimer();
	virtual void EventCallback();

 private:
	int	_cmd;
	layer *_dl;
};

#endif
